Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions

# DrawableRegion Class Reference

This is a base class for GraphicsWindow (actually, GraphicsOutput) and DisplayRegion, both of which are conceptually rectangular regions into which drawing commands may be issued. More...

Inheritance diagram for DrawableRegion:

List of all members.

## Public Types
enum | RenderTexturePlane { RTPStencil = 0, RTPDepthStencil = 1, RTPColor = 2, RTPAuxRgba0 = 3, RTPAuxRgba1 = 4, RTPAuxRgba2 = 5, RTPAuxRgba3 = 6, RTPAuxHrgba0 = 7, RTPAuxHrgba1 = 8, RTPAuxHrgba2 = 9, RTPAuxHrgba3 = 10, RTPAuxFloat0 = 11, RTPAuxFloat1 = 12, RTPAuxFloat2 = 13, RTPAuxFloat3 = 14, RTPDepth = 15, RTPCOUNT = 16 }
## Public Member Functions
| disableClears ()
| Disables both the color and depth clear.
bool | getClearActive (int n)
| Gets the clear-active flag for any bitplane.
VBase4 const | getClearColor ()
| Returns the current clear color value.
bool | getClearColorActive ()
| Returns the current setting of the flag that indicates whether the color buffer should be cleared every frame.
float | getClearDepth ()
| Returns the current clear depth value.
bool | getClearDepthActive ()
| Returns the current setting of the flag that indicates whether the depth buffer should be cleared every frame.
unsigned int | getClearStencil ()
| Returns the current clear stencil value.
bool | getClearStencilActive ()
| Returns the current setting of the flag that indicates whether the color buffer should be cleared every frame.
VBase4 const | getClearValue (int n)
| Returns the clear value for any bitplane.
float | getPixelFactor ()
| Returns the amount by which the height and width of the region will be scaled internally, based on the zoom factor set by set_pixel_zoom().
float | getPixelZoom ()
| Returns the value set by set_pixel_zoom(), regardless of whether it is being respected or not.
bool | isAnyClearActive ()
| Returns true if any of the clear types (so far there are just color or depth) have been set active, or false if none of them are active and there is no need to clear.
| setClearActive (int n, bool clear_aux_active)
| Sets the clear-active flag for any bitplane.
| setClearColor (VBase4 const color)
| Sets the clear color to the indicated value.
| setClearColorActive (bool clear_color_active)
| Toggles the flag that indicates whether the color buffer should be cleared every frame.
| setClearDepth (float depth)
| Sets the clear depth to the indicated value.
| setClearDepthActive (bool clear_depth_active)
| Toggles the flag that indicates whether the depth buffer should be cleared every frame.
| setClearStencil (unsigned int stencil)
| setClearStencilActive (bool clear_stencil_active)
| Toggles the flag that indicates whether the stencil buffer should be cleared every frame.
| setClearValue (int n, VBase4 const clear_value)
| Sets the clear value for any bitplane.
| setPixelZoom (float pixel_zoom)
| Sets the amount by which the pixels of the region are scaled internally when filling the image interally.
bool | supportsPixelZoom ()
| Returns true if a call to set_pixel_zoom() will be respected, false if it will be ignored.
## Static Public Member Functions
static int | getRenderbufferType (int plane)
| Returns the RenderBuffer.Type that corresponds to a RenderTexturePlane.

## Detailed Description

This is a base class for GraphicsWindow (actually, GraphicsOutput) and DisplayRegion, both of which are conceptually rectangular regions into which drawing commands may be issued.

Sometimes you want to deal with a single display region, and sometimes you want to deal with the whole window at once, particularly for issuing clear commands and capturing screenshots.

## Member Enumeration Documentation

enum RenderTexturePlane

Enumerator:

  RTPStencil |
  RTPDepthStencil |
  RTPColor |
  RTPAuxRgba0 |
  RTPAuxRgba1 |
  RTPAuxRgba2 |
  RTPAuxRgba3 |
  RTPAuxHrgba0 |
  RTPAuxHrgba1 |
  RTPAuxHrgba2 |
  RTPAuxHrgba3 |
  RTPAuxFloat0 |
  RTPAuxFloat1 |
  RTPAuxFloat2 |
  RTPAuxFloat3 |
  RTPDepth |
  RTPCOUNT |

## Member Function Documentation

disableClears | ( |  | ) |

Disables both the color and depth clear.

See set_clear_color_active and set_clear_depth_active.

bool getClearActive | ( | int | n | ) |

Gets the clear-active flag for any bitplane.

VBase4 const getClearColor | ( |  | ) |

Returns the current clear color value.

This is the value that will be used to clear the color buffer every frame, but only if get_clear_color_active() returns true. If get_clear_color_active() returns false, this is meaningless.

bool getClearColorActive | ( |  | ) |

Returns the current setting of the flag that indicates whether the color buffer should be cleared every frame.

See set_clear_color_active().

float getClearDepth | ( |  | ) |

Returns the current clear depth value.

This is the value that will be used to clear the depth buffer every frame, but only if get_clear_depth_active() returns true. If get_clear_depth_active() returns false, this is meaningless.

bool getClearDepthActive | ( |  | ) |

Returns the current setting of the flag that indicates whether the depth buffer should be cleared every frame.

See set_clear_depth_active().

unsigned int getClearStencil | ( |  | ) |

Returns the current clear stencil value.

This is the value that will be used to clear the stencil buffer every frame, but only if get_clear_stencil_active() returns true. If get_clear_stencil_active() returns false, this is meaningless.

bool getClearStencilActive | ( |  | ) |

Returns the current setting of the flag that indicates whether the color buffer should be cleared every frame.

See set_clear_stencil_active().

VBase4 const getClearValue | ( | int | n | ) |

Returns the clear value for any bitplane.

float getPixelFactor | ( |  | ) |

Returns the amount by which the height and width of the region will be scaled internally, based on the zoom factor set by set_pixel_zoom().

This will return 1.0 if the pixel_zoom was not set or if it is not being respected (for instance, because the underlying renderer doesn't support it--see supports_pixel_zoom).

float getPixelZoom | ( |  | ) |

Returns the value set by set_pixel_zoom(), regardless of whether it is being respected or not.

Also see get_pixel_factor().

static int getRenderbufferType | ( | int | plane | ) | `[static]`

Returns the RenderBuffer.Type that corresponds to a RenderTexturePlane.

bool isAnyClearActive | ( |  | ) |

Returns true if any of the clear types (so far there are just color or depth) have been set active, or false if none of them are active and there is no need to clear.

setClearActive | ( | int | n,
|  | bool | clear_aux_active
| ) |  |

Sets the clear-active flag for any bitplane.

setClearColor | ( | VBase4 const | color | ) |

Sets the clear color to the indicated value.

This is the value that will be used to clear the color buffer every frame, but only if get_clear_color_active() returns true. If get_clear_color_active() returns false, this is meaningless.

setClearColorActive | ( | bool | clear_color_active | ) |

Toggles the flag that indicates whether the color buffer should be cleared every frame.

If this is true, the color buffer will be cleared to the color indicated by set_clear_color(); otherwise, it will be left alone.

setClearDepth | ( | float | depth | ) |

Sets the clear depth to the indicated value.

This is the value that will be used to clear the depth buffer every frame, but only if get_clear_depth_active() returns true. If get_clear_depth_active() returns false, this is meaningless.

setClearDepthActive | ( | bool | clear_depth_active | ) |

Toggles the flag that indicates whether the depth buffer should be cleared every frame.

If this is true, the depth buffer will be cleared to the depth value indicated by set_clear_depth(); otherwise, it will be left alone.

setClearStencil | ( | unsigned int | stencil | ) |

setClearStencilActive | ( | bool | clear_stencil_active | ) |

Toggles the flag that indicates whether the stencil buffer should be cleared every frame.

If this is true, the stencil buffer will be cleared to the value indicated by set_clear_stencil(); otherwise, it will be left alone.

setClearValue | ( | int | n,
|  | VBase4 const | clear_value
| ) |  |

Sets the clear value for any bitplane.

setPixelZoom | ( | float | pixel_zoom | ) |

Sets the amount by which the pixels of the region are scaled internally when filling the image interally.

Setting this number larger makes the pixels blockier, but may make the rendering faster, particularly for software renderers. Setting this number to 2.0 reduces the number of pixels that have to be filled by the renderer by a factor of 2.0. It doesn't make sense to set this lower than 1.0.

It is possible to set this on either individual DisplayRegions or on overall GraphicsWindows, but you will get better performance for setting it on the window rather than its individual DisplayRegions. Also, you may not set it on a DisplayRegion that doesn't have both clear_color() and clear_depth() enabled.

This property is only supported on renderers for which it is particularly useful--currently, this is the tinydisplay software renderer. Other kinds of renderers allow you to set this property, but ignore it.

bool supportsPixelZoom | ( |  | ) |

Returns true if a call to set_pixel_zoom() will be respected, false if it will be ignored.

If this returns false, then get_pixel_factor() will always return 1.0, regardless of what value you specify for set_pixel_zoom().

This may return false if the underlying renderer doesn't support pixel zooming, or if you have called this on a DisplayRegion that doesn't have both set_clear_color() and set_clear_depth() enabled.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties